type SpyNonSetupConfig = {
    useOwnEquals: boolean;
    enforceOrder: boolean;
    useGenericReactMocks: boolean;
    afterEachCb?: () => void;
};
export type SpyConfig = SpyNonSetupConfig & {
    afterEach?: (cb: () => void) => void;
    beforeEach?: (cb: () => void) => void;
    expect?: {
        addSnapshotSerializer: (serializer: any) => void;
        getState: () => {
            currentTestName?: string;
        };
    };
    runner: 'jest' | 'vitest' | 'other';
};
export declare const Config: {
    useOwnEquals: boolean;
    enforceOrder: boolean;
    useGenericReactMocks: boolean;
    afterEachCb?: (() => void) | undefined;
    afterEach?: ((cb: () => void) => void) | undefined;
    beforeEach?: ((cb: () => void) => void) | undefined;
    expect?: {
        addSnapshotSerializer: (serializer: any) => void;
        getState: () => {
            currentTestName?: string;
        };
    } | undefined;
    runner: 'jest' | 'vitest' | 'other';
};
export declare const configure: (config: Partial<SpyNonSetupConfig>) => void;
export declare const configureAll: (config?: Partial<SpyConfig>) => void;
export {};
