const NOP = () => void 0;
const __getTypeOfObject = (o) => Object.prototype.toString.call(o).split(" ")[1].slice(0, -1);
const __serializeProp = (key, value, custom, serialized) => typeof value === "string" ? `${key}="${value}"` : `${key}={${__serialize(value, custom, serialized)}}`;
const __serializeProps = (o, custom, serialized) => {
  const elemProps = o.props;
  const props = [];
  Object.entries(elemProps).forEach(([k, v]) => {
    if (v !== void 0 && k !== "children")
      props.push(__serializeProp(k, v, custom, serialized));
  });
  if (o.key)
    props.push(__serializeProp("key", o.key, custom, serialized));
  if (o.ref)
    props.push(__serializeProp("ref", o.ref, custom, serialized));
  if (!props.length)
    return "";
  return " " + props.join(" ");
};
const __serializeChildren = (o, custom, serialized) => {
  const children = o.props.children;
  if (!children)
    return "";
  if (typeof children === "string")
    return children;
  return Array.isArray(children) ? children.map((v) => __serialize(v, custom, serialized)).join("") : __serialize(children, custom, serialized);
};
const __reactTypeNameReader = {
  String: (type) => type,
  Function: (type) => type.name,
  Symbol: (type) => Symbol.keyFor(type) === "react.fragment" && "Fragment" || void 0
};
const getTypeName = (type) => (__reactTypeNameReader[__getTypeOfObject(type)] || NOP)(type);
const __serializeReactElement = (o, custom, serialized) => {
  const type = getTypeName(o.type) || "UNKNOWN";
  const children = __serializeChildren(o, custom, serialized);
  return `<${type}${__serializeProps(o, custom, serialized)}${children ? `>${children}</${type}>` : " />"}`;
};
const __serializeReact = (o, custom, serialized) => {
  const symbolKey = Symbol.keyFor(o.$$typeof);
  switch (symbolKey) {
    case "react.element":
      return __serializeReactElement(o, custom, serialized);
    default:
      return;
  }
};
const __serializeIfReact = (o, custom, serialized) => {
  if ("$$typeof" in o && Object.prototype.toString.call(o.$$typeof) === "[object Symbol]") {
    const key = Symbol.keyFor(o.$$typeof);
    if (key && key.indexOf("react.") === 0)
      return __serializeReact(o, custom, serialized);
  }
};
const __serializerByType = {
  BigInt: (o) => `${String(o)}n`,
  RegExp: (o) => `/${String(o)}/`,
  String: (o) => o.indexOf('"') === -1 && o.indexOf("'") !== -1 ? `"${o}"` : `'${o}'`,
  Function: (o) => o.name || "Function",
  AsyncFunction: (o) => o.name || "AsyncFunction",
  Date: (o) => `new Date(${Number(o)})`,
  Number: (o) => String(o),
  Boolean: (o) => String(o),
  Set: (o) => `new Set(${__serializeArray([...o.keys()], void 0, [])})`,
  Map: (o) => `new Map(${__serializeArray([...o.entries()], void 0, [])})`,
  Symbol: (o) => Symbol.keyFor(o) === void 0 ? o.toString() : `Symbol.for('${Symbol.keyFor(o)}')`,
  Error: (o) => `new ${o.name}('${o.message}')`,
  Window: () => `window`,
  Document: () => `document`
};
const __serializeArray = (o, custom, serialized) => {
  const results = [];
  for (let i = 0; i < o.length; i++) {
    results.push(__serialize(o[i], custom, serialized));
  }
  return `[${results.join(", ")}]`;
};
const __serializeOptArray = (o, custom, serialized) => {
  if (Array.isArray(o))
    return __serializeArray(o, custom, serialized);
};
const __serializeHTML = (o) => {
  var _o$constructor;
  const objectType = (_o$constructor = o.constructor) == null ? void 0 : _o$constructor.name;
  if (/^HTML[a-zA-Z]*Element$/.test(objectType))
    return objectType;
};
const __serializeObject = (o, custom, serialized) => {
  var _o$constructor2;
  const oKeys = Object.keys(o);
  oKeys.sort();
  const results = [];
  for (let i = 0; i < oKeys.length; i++) {
    const key = oKeys[i];
    results.push(`${key}: ${__serialize(o[key], custom, serialized)}`);
  }
  const objectType = (_o$constructor2 = o.constructor) == null ? void 0 : _o$constructor2.name;
  const displayedType = objectType === "Object" ? "" : objectType;
  return `${displayedType}{${results.join(", ")}}`;
};
const Serialize = {
  custom: (o, custom) => custom && custom(o),
  undefOrNull: (o) => o === void 0 && "undefined" || o === null && "null" || void 0,
  flat: (o) => (__serializerByType[__getTypeOfObject(o)] || NOP)(o),
  cyclomatic: (o, _, serialized) => serialized.indexOf(o) !== -1 && ">CYCLOMATIC<" || void 0,
  react: __serializeIfReact,
  array: __serializeOptArray,
  HTML: __serializeHTML
};
const __serialize = (o, custom, serialized) => Serialize.custom(o, custom, serialized) || Serialize.undefOrNull(o, custom, serialized) || Serialize.flat(o, custom, serialized) || Serialize.cyclomatic(o, custom, serialized) || ((nextSerialized) => Serialize.react(o, custom, nextSerialized) || Serialize.array(o, custom, nextSerialized) || Serialize.HTML(o, custom, nextSerialized) || __serializeObject(o, custom, nextSerialized))([...serialized, o]);
const _serialize = (o, custom) => __serialize(o, custom, []);
const Serializer = {
  run: (o) => _serialize(o),
  create: (custom) => (o) => _serialize(o, custom)
};
const IGNORE = Symbol.for("__Spy_IGNORE__");
const serialize = Serializer.create((o) => o === IGNORE && ">IGNORED<" || void 0);
const SPY_COMPARE_FAILED = "Spy.COMPARE failed";
const SPY_MAPPER_FAILED = "Spy.MAPPER failed";
class SpyComparator {
  constructor(comparator) {
    this._func = comparator;
  }
  compare(arg) {
    const result = this._func(arg);
    if (typeof result === "string")
      return [`${SPY_MAPPER_FAILED} [${result}]`];
    if (result === false)
      return [SPY_COMPARE_FAILED];
    return void 0;
  }
}
const COMPARE = (comparator) => new SpyComparator(comparator);
const MAPPER = (from, to) => new SpyComparator((mapper) => {
  const result = mapper(...Array.isArray(from) ? from : [from]);
  const diff = differenceOf(result, to);
  return diff ? `${serialize(result)} did not match ${serialize(to)}: ${diff}` : void 0;
});
const __different = (type) => ["different " + type];
const __diff = (a, b, useOwnEquals, alreadyComparedArray = []) => {
  if (a === IGNORE || b === IGNORE)
    return void 0;
  if (a instanceof SpyComparator)
    return a.compare(b);
  if (b instanceof SpyComparator)
    return b.compare(a);
  if (a === b)
    return void 0;
  if (a === void 0 || b === void 0)
    return ["one was undefined"];
  if (a === null || b === null)
    return ["one was null"];
  const aClass = Object.prototype.toString.call(a);
  const bClass = Object.prototype.toString.call(b);
  if (aClass !== bClass)
    return __different(`object types: ${aClass} <-> ${bClass}`);
  switch (aClass) {
    case "[object RegExp]":
      if (String(a) === String(b)) {
        return void 0;
      }
      return __different("regexp");
    case "[object String]":
      return __different("string");
    case "[object Function]":
      return __different("function");
    case "[object AsyncFunction]":
      return __different("async function");
    case "[object Number]":
      if (isNaN(a) && isNaN(b)) {
        return void 0;
      }
      return __different("number");
    case "[object BigInt]":
      return __different("BigInt");
    case "[object Date]":
      if (Number(a) === Number(b)) {
        return void 0;
      }
      return __different("date");
    case "[object Boolean]":
      return __different("bool");
    case "[object Symbol]":
      return __different("symbols");
    case "[object Error]":
      if (String(a) === String(b)) {
        return void 0;
      }
      return __different("error");
    default:
      if (a.constructor !== b.constructor) {
        return __different("constructor");
      }
  }
  if (useOwnEquals && "equals" in a && typeof a.equals === "function") {
    if (a.equals(b)) {
      return void 0;
    }
    return [
      "own equals method failed <- Maybe you want to disable the usage of own equals implementation? [ Use: spy.configure({useOwnEquals: false}) ]"
    ];
  }
  if (alreadyComparedArray.indexOf(a) !== -1) {
    return void 0;
  }
  const compared = [...alreadyComparedArray, a];
  const keys = Array.from(new Set(Object.keys(a).concat(Object.keys(b))));
  for (const key of keys) {
    const diff = __diff(a[key], b[key], useOwnEquals, compared);
    if (diff !== void 0) {
      return [key, ...diff];
    }
  }
  return void 0;
};
const __serializeDifferentProp = (obj, diff) => {
  let toSerialize = obj;
  diff.slice(0, -1).forEach((key) => {
    toSerialize = toSerialize[key];
  });
  return serialize(toSerialize);
};
const __diffToStr = (diff, info = "") => {
  if (diff.length === 1)
    return diff[0];
  return `--> ${diff[0]} / ` + diff.slice(1).join(" / ") + info;
};
const differenceOf = (a, b, config = { useOwnEquals: true }) => {
  const diff = __diff(a, b, config.useOwnEquals);
  if (!diff)
    return void 0;
  const diffStr = __diffToStr(diff);
  if (diff.length < 2)
    return diffStr;
  const diffProp1 = __serializeDifferentProp(a, diff);
  const lastPart = diff[diff.length - 1];
  if (lastPart.indexOf(SPY_MAPPER_FAILED) === 0)
    return diffStr;
  const info = lastPart === SPY_COMPARE_FAILED ? `called with: ${diffProp1}` : `${diffProp1} != ${__serializeDifferentProp(b, diff)}`;
  return `${diffStr} [${info}]`;
};
const toError = (msgOrError, spyName) => msgOrError instanceof Error ? msgOrError : new Error(msgOrError || `${spyName} was requested to throw`);
const symbolName = Symbol("__Spy_name__");
const symbolSnap = Symbol("__Spy_snap__");
const symbolSnapSerializer = Symbol("__Spy_snapSerializer__");
const symbolIsSpy = Symbol("__Spy_isSpy__");
const symbolFunc = Symbol("__Spy_func__");
const symbolCalls = Symbol("__Spy_calls__");
const symbolConfig = Symbol("__Spy_config__");
const symbolIndex = Symbol("__Spy_index__");
const symbolOnRestore = Symbol("__Spy_onRestore__");
const Symbols = {
  name: symbolName,
  snap: symbolSnap,
  snapSerializer: symbolSnapSerializer,
  isSpy: symbolIsSpy,
  func: symbolFunc,
  calls: symbolCalls,
  config: symbolConfig,
  index: symbolIndex,
  onRestore: symbolOnRestore
};
const restoreAttributeForEntry = (value) => {
  var _a, _b;
  const { obj, method, methodName } = value;
  if (obj) {
    (_b = (_a = obj[methodName]) == null ? void 0 : _a[Symbols.onRestore]) == null ? void 0 : _b.call(_a);
    obj[methodName] = method;
  }
};
class SpyRegistry {
  /**
   * The SpyRegistry is a class to handle the
   * correct restoration of spied objects.
   *
   * You may push an objects information about
   * a spied method to store it and be able to
   * restore it at any time.
   * Consider the SpyRegistry as information storage
   * for spied objects.
   *
   * @constructor
   */
  constructor() {
    this.register = {};
    this.persReg = {};
    this.registerCount = 0;
  }
  /**
   * If called, the SypRegistry will be resetting to its initial state.
   * Exception: the unique register count will not be touched.
   * Meaning that all stored object information will be restored
   * to their individual previous state.
   */
  restoreAll() {
    Object.values(this.register).forEach((entry) => {
      restoreAttributeForEntry(entry);
    });
    this.register = {};
  }
  /**
   * If called, the SpyRegistry will restore the object,
   * which was registered at given index and is getting lose
   * of the stored information.
   *
   * If the registry entry for the given index does not exist,
   * nothing will happen.
   *
   * @param {number} index -> the unique identifier of stored information.
   */
  restore(index) {
    const entry = this.register[index];
    if (entry) {
      restoreAttributeForEntry(entry);
      delete this.register[index];
    }
  }
  /**
   * If called, the SpyRegistry will store the given information.
   * The unique identifier index will be returned.
   *
   * @param {Object} obj -> The related object, which will be spied.
   * @param {string} methodName -> The name of the mocked method.
   * @return {number} -> The unique store index.
   */
  push(obj, methodName) {
    this.registerCount += 1;
    this.register[this.registerCount] = {
      obj,
      method: obj[methodName],
      methodName
    };
    return this.registerCount;
  }
  /**
   * If called, the stored method for the corresponding index
   * will be returned. If the registry entry does not exist,
   * undefined will be returned.
   *
   * @param {number} index -> the unique identifier of stored information.
   * @return {any} -> Any stored information can be returned.
   *                   BUT: Usually this method returns a function or
   *                        undefined.
   */
  getOriginalMethod(index) {
    const entry = this.register[index];
    if (entry) {
      return entry.method;
    }
  }
  /**
   * If called, the stored method will be moved from the standard
   * registry into the persistent registry or vice versa.
   * This can make restore and restoreAll having no effect anymore.
   *
   * @param {number} index -> the unique identifier of stored information.
   * @param {boolean} intoPersReg -> boolean to determine the moving
   *                                 direction.
   */
  persist(index, intoPersReg) {
    const fromReg = intoPersReg ? this.register : this.persReg;
    const toReg = intoPersReg ? this.persReg : this.register;
    const entry = fromReg[index];
    if (entry) {
      toReg[index] = entry;
      delete fromReg[index];
    }
  }
}
const defaults = {
  useOwnEquals: false,
  enforceOrder: true,
  useGenericReactMocks: false,
  afterEach: global.afterEach,
  beforeEach: global.beforeEach,
  expect: global.expect,
  runner: process.env.JEST_WORKER_ID !== void 0 ? "jest" : "vitest"
};
const Config = { ...defaults };
const configure = (config) => configureAll(config);
const configureAll = (config = {}) => {
  Object.entries(config).forEach(([name, value]) => {
    if (value !== void 0) {
      Config[name] = value;
    }
  });
};
const uninitialized = (method) => () => {
  throw new Error(`Method '${String(method)}' was not initialized on Mock.`);
};
const createMock = (obj, methods, spyOn, callsFactory) => {
  const mock = registerMock(obj, spyOn, callsFactory);
  methods.forEach((method) => {
    mock[method] = uninitialized(method);
  });
  return mock;
};
const registerMock = (mocked, spyOn, callsFactory) => {
  const mock = {};
  const { beforeEach, expect } = Config;
  if (!beforeEach || !expect)
    throw new Error("You need to call Spy.setup() in order to use mocks.");
  const { currentTestName } = expect.getState();
  if (currentTestName)
    throw new Error("Mocks can only be created outside of tests");
  const activeMethods = /* @__PURE__ */ new Set();
  beforeEach(() => {
    initMock({ mocked, mock, callsFactory, activeMethods }, spyOn);
  });
  return mock;
};
const couldNotInitError = (additional) => new Error(`Could not initialize mock because:
${additional}`);
const initMock = (mockInfo, spyOn) => {
  const { mocked, mock, callsFactory, activeMethods } = mockInfo;
  Object.keys(mock).forEach((method) => {
    if (activeMethods.has(method))
      return;
    try {
      const spy = spyOn(mocked, method);
      mockInfo.activeMethods.add(method);
      if (callsFactory) {
        spy.calls(callsFactory(method));
        spy.displayName = method;
      }
      spy[Symbols.onRestore] = () => {
        mockInfo.activeMethods.delete(method);
      };
      mock[method] = spy;
    } catch (e) {
      let msg = e.message;
      const utilName = Config.runner === "jest" ? "jest" : Config.runner === "vitest" ? "vi" : void 0;
      if (utilName && msg.includes("has only a getter")) {
        const actual = utilName === "jest" ? `() => ({ ...jest.requireActual('<module-name>') })` : `async () => ({ ...((await vi.importActual('<module-name>')) as any) })`;
        msg += `
Inserting a module mock might should resolve this problem. Run this code beforehand:

${utilName}.mock('<module-name>');

Or if you don't want to mock everything from this module, you can use this:

${utilName}.mock('<module-name>', ${actual});`;
      }
      throw couldNotInitError(msg);
    }
  });
};
const createGenericComponent = (method) => (props) => {
  const { children, ...rest } = props;
  const dataProps = {};
  return {
    $$typeof: Symbol.for("react.element"),
    type: "samp",
    props: { "data-component": method, children, ...dataProps },
    ref: null
  };
};
const createMinimalComponent = () => () => null;
const CallOrder = {
  Idx: 0,
  lastCheck: 0
};
const registry = new SpyRegistry();
let __LOCK__ = true;
const SpyHelperFunctions = {
  getCalls: (spy) => {
    const allCalls = spy[Symbols.calls];
    if (!Config.enforceOrder)
      return allCalls;
    return allCalls.filter(({ order }) => order > CallOrder.lastCheck);
  }
};
const SpyFunctions = {
  /**
   * Configures this spy behavior in a special
   * way. Passing in an object that contains
   * meaningful attributes can configure:
   *
   * - useOwnEquals:boolean -> toggles the usage of own
   *                           implementation of "equals"
   *                           matcher, e.g. for comparing
   *                           call params with "wasCalledWith".
   *
   * - persistent:boolean -> toggles the persistence of the spy.
   *                         I.e. making it restorable or not.
   *                         Throws for not mocking spies.
   *
   * @param {Object} config <- An object containing attributes
   *                         for special configuration
   * @return {SpyInstance} <- BuilderPattern.
   */
  configure(config) {
    if (config.useOwnEquals !== void 0) {
      this[Symbols.config].useOwnEquals = config.useOwnEquals;
    }
    if (config.persistent !== void 0) {
      if (!this[Symbols.index]) {
        throw new Error(
          `

${this[Symbols.name]} can not be configured to be persistent! It does not mock any object.`
        );
      }
      this[Symbols.config].persistent = config.persistent;
      registry.persist(this[Symbols.index], this[Symbols.config].persistent);
    }
    return this;
  },
  /**
   * Accepts multiple functions. If called more often,
   * calling always the last supplied function.
   *
   * @param {Array<Function>} funcs
   *     -> The iterative provided functions
   *        can be accessed as array.
   *        And will be called one by one
   *        for each made call on the spy.
   *
   * @return {SpyInstance} <- BuilderPattern.
   */
  calls(...funcs) {
    if (funcs.length === 0) {
      this[Symbols.func] = () => {
      };
      return this;
    }
    const max = funcs.length - 1;
    let counter = -1;
    this[Symbols.func] = (...args) => {
      counter++;
      return funcs[max < counter ? max : counter](...args);
    };
    return this;
  },
  /**
   * Accepts multiple return values. If called more often,
   * returns always the last supplied return value.
   *
   * @param {Array<any>} args -> The iterative provided arguments
   *                             can be accessed as array.
   *                             And will be returned one by one
   *                             for each made call.
   *
   * @return {SpyInstance} <- BuilderPattern.
   */
  returns(...args) {
    return this.calls(...args.map((arg) => () => arg));
  },
  /**
   * Accepts multiple values, which will be resolved sequentially.
   * If called more often, resolves always the last supplied value.
   *
   * @param {Array<any>} args -> The iterative provided arguments
   *                             can be accessed as array.
   *                             And will be resolved one by one
   *                             for each made call.
   *
   * @return {SpyInstance} <- BuilderPattern.
   */
  resolves(...args) {
    return this.returns(...(args.length ? args : [void 0]).map((arg) => Promise.resolve(arg)));
  },
  /**
   * Accepts multiple values, which will be rejected sequentially.
   * If called more often, rejects always the last supplied value.
   *
   * @param {Array<OptionalMessageOrError>} msgOrErrors
   *              -> The iterative provided arguments
   *                 can be accessed as array.
   *                 And will be rejected one by one
   *                 for each made call.
   *
   * @return {SpyInstance} <- BuilderPattern.
   */
  rejects(...msgOrErrors) {
    return this.calls(
      ...(msgOrErrors.length ? msgOrErrors : [void 0]).map(
        (msgOrError) => () => Promise.reject(toError(msgOrError, this[Symbols.name]))
      )
    );
  },
  /**
   * Will make the spy throw an Error, if called next time.
   * The error message can be provided as parameter.
   *
   * @param {OptionalMessageOrError} msgOrError -> Will be the error message.
   *
   * @return {SpyInstance} <- BuilderPattern
   */
  throws(msgOrError) {
    this[Symbols.func] = () => {
      throw toError(msgOrError, this[Symbols.name]);
    };
    return this;
  },
  /**
   * Deletes all notices of made calls with this spy.
   *
   * @return {SpyInstance} <- BuilderPattern
   */
  reset() {
    this[Symbols.calls] = [];
    return this;
  },
  /**
   * Restores the last by this spy manipulated object
   * and removes this special mock.
   *
   * Restoring objects does not disable any
   * other behaviors/features of the spies.
   *
   * If the spy was configured persistent, than this
   * method will throw an exception.
   *
   * Other than "Spy.restoreAll" this method only removes
   * a maximum of one mock.
   *
   * @return {SpyInstance} <- BuilderPattern
   */
  restore() {
    if (this[Symbols.config].persistent) {
      throw new Error(`

${this[Symbols.name]} can not be restored! It was configured to be persistent.`);
    }
    registry.restore(this[Symbols.index]);
    return this;
  },
  /**
   * Makes the spy behave like the mocked
   * function. If no function was mocked by
   * this spy, it will do nothing if called.
   *
   * This function works exactly like
   * spy.transparentAfter(0).
   *
   * For example:
   * const spy = Spy.on(someObject, 'someFunc');
   * someObject.someFunc(); // calls only the spy
   * spy.transparent();
   * someObject.someFunc(); // behaves like calling the original method
   *
   * @return {SpyInstance} <- BuilderPattern
   */
  transparent() {
    return this.transparentAfter(0);
  },
  /**
   * If called with n as callCount this will make
   * the spy call the mocked function after called
   * the n'th time. For any spy that does not mock
   * any objects attribute, this will make the spy
   * do nothing if called after the n'th time.
   *
   * If the mocked function will get called again,
   * the made calls will still be registered.
   *
   * For example:
   * Spy.on(someObject, 'someFunc').transparentAfter(2);
   * someObject.someFunc(); // calls only the spy
   * someObject.someFunc(); // calls only the spy
   * someObject.someFunc(); // behaves like calling the original method
   *
   * @param {number} callCount <- The number after which the mocked function
   *                              should be called again.
   *
   * @return {SpyInstance} <- BuilderPattern
   */
  transparentAfter(callCount) {
    const oldFunc = this[Symbols.func];
    this[Symbols.func] = (...args) => {
      if (this[Symbols.calls].length > callCount) {
        const originalMethod = registry.getOriginalMethod(this[Symbols.index]);
        if (originalMethod) {
          return originalMethod(...args);
        }
        return;
      }
      return oldFunc(...args);
    };
    return this;
  },
  /**
   * This method allows to customize the snapshot serialization of the spy.
   * Only works for Jest test runner as of now.
   *
   * @return {SpyInstance} <- BuilderPattern
   */
  addSnapshotSerializer(serialize2) {
    if (typeof serialize2 === "function") {
      this[Symbols.snapSerializer] = serialize2;
      const calls = this[Symbols.calls];
      const lastArgs = calls.length ? calls[calls.length - 1].args : [];
      this[Symbols.snap] = serialize2(...lastArgs);
    } else {
      this[Symbols.snap] = serialize2;
    }
    return this;
  },
  /**
   * Checks if the spy was called callCount times often.
   *
   * If callCount is not provided then it only
   * checks if the spy was called at least once.
   *
   * Throws an error if the expectation is wrong.
   *
   * @param {?number} callCount -> Is the number of expected calls made.
   */
  wasCalled(callCount) {
    const calls = SpyHelperFunctions.getCalls(this);
    const madeCalls = calls.length;
    if (callCount !== void 0) {
      if (madeCalls !== callCount) {
        throw new Error(
          `

${this[Symbols.name]} was called ${madeCalls} times, but there were expected ${callCount} calls.

Actually there were:

` + this.showCallArguments()
        );
      }
    } else if (madeCalls === 0) {
      if (this[Symbols.calls].length) {
        throw new Error(
          `

${this[Symbols.name]} was not called, but there was expected at least one call.

Actually there were:

` + this.showCallArguments()
        );
      } else {
        throw new Error(`

${this[Symbols.name]} was never called!

`);
      }
    }
    if (callCount !== 0) {
      const checked = calls[(callCount || 1) - 1];
      CallOrder.lastCheck = checked.order;
    }
  },
  /**
   * Checks if the spy was call history matches the expectation.
   *
   * The call history has to match the call count and order.
   * Single arguments will be automatically wrapped as array, e.g.:
   *            1, 2, 3 -> [1], [2], [3]
   * ** Inspired by jest test.each **
   *
   * Throws an error if the expectation is wrong.
   *
   * @param {Array<Array<any> | any>} callHistory
   *          -> Are the expected made call arguments in correct order.
   */
  hasCallHistory(...callHistory) {
    const calls = SpyHelperFunctions.getCalls(this);
    const madeCalls = calls.length;
    const callCount = callHistory.length;
    if (madeCalls !== callCount) {
      throw new Error(
        `

${this[Symbols.name]} was called ${madeCalls} times, but the expected call history includes exactly ${callHistory.length} calls.

Actually there were:

` + this.showCallArguments()
      );
    }
    if (callCount === 0) {
      throw new Error("\n\nPlease use 'wasNotCalled' instead of calling 'hasCallHistory' without any arguments");
    }
    const modifiedCallHistory = callHistory.map((arg) => Array.isArray(arg) ? arg : [arg]);
    let hasErrors = false;
    const diffInfo = calls.map((call, index) => {
      const diff = differenceOf(call.args, modifiedCallHistory[index], this[Symbols.config]);
      if (diff)
        hasErrors = true;
      return diff;
    });
    if (hasErrors)
      throw new Error(
        `

${this[Symbols.name]} was expected to be called with the following arguments in the given order:

${modifiedCallHistory.map((entry, index) => `call ${index}: ${serialize(entry)}`).join("\n")}

Actually there were:

` + this.showCallArguments(diffInfo)
      );
    CallOrder.lastCheck = calls[callCount - 1].order;
  },
  /**
   * Checks that the spy was never called.
   * Throws an error if the spy was called at least once.
   */
  wasNotCalled() {
    const calls = SpyHelperFunctions.getCalls(this);
    const madeCalls = calls.length;
    if (madeCalls !== 0) {
      throw new Error(
        `

${this[Symbols.name]} was not expected to be called, but was called ${madeCalls} times.

Actually there were:

` + this.showCallArguments()
      );
    }
  },
  /**
   * Checks if the spy was called with the provided arguments.
   *
   * Throws an error if the expectation is wrong.
   *
   * For example:
   * const spy = Spy();
   * spy(arg1, arg2, arg3);
   * spy(arg4, arg5);
   * spy.wasCalledWith(arg1, arg2, arg3); // no error
   * spy.wasCalledWith(arg4, arg5); // no error
   * spy.wasCalledWith(arg1); // error!!!
   *
   * @param {Array<any>} args -> The expected arguments
   *                           for any made call.
   */
  wasCalledWith(...args) {
    const calls = SpyHelperFunctions.getCalls(this);
    const madeCalls = calls.length;
    const diffInfo = [];
    for (let i = 0; i < madeCalls; i++) {
      const checked = calls[i];
      const diff = differenceOf(checked.args, args, this[Symbols.config]);
      if (!diff) {
        CallOrder.lastCheck = checked.order;
        return;
      }
      diffInfo.push(diff);
    }
    throw new Error(
      `

${this[Symbols.name]} was expected to be called with the following arguments:

    --> ${serialize(args)}

Actually there were:

` + this.showCallArguments(diffInfo)
    );
  },
  /**
   * Checks if the spy was NOT called with the provided arguments.
   * This method checks the direct opposite of the method
   * spy.wasCalledWith.
   *
   * It throws an error if the upper method would not.
   *
   * @param {Array<any>} args -> The not expected arguments
   *                             for any made call.
   */
  wasNotCalledWith(...args) {
    let errorOccurred = false;
    try {
      this.wasCalledWith(...args);
    } catch (e) {
      errorOccurred = true;
    }
    if (!errorOccurred) {
      throw new Error(
        `

${this[Symbols.name]} was called unexpectedly with the following arguments:

    --> ${serialize(args)}

`
      );
    }
  },
  /**
   * This method returns all call arguments of all calls. Will be an empty
   * array if the spy was never called.
   *
   * For example:
   * const spy = Spy();
   * spy(arg1, arg2, arg3);
   * spy(arg4, arg5, arg6);
   * spy.getAllCallArguments();
   * // returns [[arg1, arg2, arg3], [arg4, arg5, arg6]]
   *
   * @return {Array<any[]>} -> the call arguments of all calls.
   */
  getAllCallArguments() {
    return this[Symbols.calls].map(({ args }) => args);
  },
  /**
   * This method returns the call arguments of the
   * n'th made call as array. If less than n calls were made,
   * it will throw an error.
   *
   * By default n = 1. This corresponds to callNr = 0.
   *
   * For example:
   * const spy = Spy();
   * spy(arg1, arg2, arg3);
   * spy.getCallArguments(); // returns [arg1, arg2, arg3]
   *
   * @param {number} callNr -> represents the callNr for which
   *                           the call argument should be returned.
   *
   * @return {Array<any>} -> the call arguments of the (callNr + 1)'th call.
   */
  getCallArguments(callNr = 0) {
    const madeCalls = this.getAllCallArguments();
    if (callNr % 1 !== 0 || callNr >= madeCalls.length) {
      throw new Error(
        `

The provided callNr "${callNr}" was not valid.

Made calls for ${this[Symbols.name]}:

` + this.showCallArguments()
      );
    }
    return madeCalls[callNr];
  },
  /**
   * This method returns the m'th call argument of the
   * n'th made call. If less than n calls were made, it will throw
   * an error.
   *
   * By default n = 1. This corresponds to callNr = 0.
   * By default m = 1. This corresponds to argNr = 0.
   *
   * For example:
   * const spy = Spy();
   * spy(arg1, arg2, arg3);
   * spy(arg4, arg5, arg6);
   * spy.getCallArgument() === arg1; // true
   * spy.getCallArgument(1) === arg4; // true
   * spy.getCallArgument(0, 2) === arg3; // true
   * spy.getCallArgument(1, 1) === arg5; // true
   *
   * spy.getCallArgument(1, 5) === undefined; // true
   * spy.getCallArgument(2); // throws an exception
   *
   * @param {number} callNr -> represents the callNr for which
   *                           a call argument should be returned.
   * @param {number} argNr -> represents position of the argument
   *                          when the corresponding call was made.
   *
   * @return {any} -> the (argNr + 1)'th call argument
   *                  of the (callNr + 1)'th call.
   */
  getCallArgument(callNr = 0, argNr = 0) {
    return this.getCallArguments(callNr)[argNr];
  },
  /**
   * Returns the latest call argument.
   *
   * @param {number} argNr -> represents position of the argument
   *                          when the corresponding call was made.
   *
   * @return {any} -> the props
   */
  getLatestCallArgument(argNr = 0) {
    const allArgs = this.getAllCallArguments();
    if (!allArgs.length) {
      throw new Error(`

${this[Symbols.name]} was never called!

`);
    }
    return this.getCallArgument(allArgs.length - 1, argNr);
  },
  /**
   * This method returns the props of a mocked React component.
   * Convenience naming for already existing functionality.
   *
   * @return {any} -> the props
   */
  getProps() {
    return this.getLatestCallArgument();
  },
  /**
   * Checks if the spy was last call was done with the provided first argument.
   *
   * It throws an error otherwise.
   *
   * @param {any} props
   *
   */
  hasProps(props) {
    const currentProps = this.getProps();
    const diff = differenceOf(currentProps, props, this[Symbols.config]);
    if (!diff)
      return;
    throw new Error(
      `

${this[Symbols.name]} was expected to have the following props:

    --> ${serialize(props)}

But the current props are:

    ${serialize(currentProps)}
    ${diff}`
    );
  },
  /**
   * This method returns the number of made calls on the spy.
   *
   * @return {number} -> the number of made calls.
   */
  getCallCount() {
    return this.getAllCallArguments().length;
  },
  /**
   * This method returns a formatted text string for debugging
   * made calls with the given Spy. It is used also internally
   * if some wrong assertions were made on the Spy.
   * Some sample:
   *
   * call 0: [{"_key":"test1"}]
   * call 1: [{"_key":"test1"},{"_key":"test2"}]
   * call 2: [{"_key":"test3"},{"_key":"test2"},{"_key":"test1"}]
   * call 3: [{"_key":"test2"}]
   *
   * If an array of strings is provided, the given strings will
   * be printed just below params of each call.
   *
   * Some sample: additionalInformation = [
   *     '-> 0 / _key / different string',
   *     '-> 1 / _key / different object types'
   * ]
   *
   * call 0: [{"_key":"test1"}]
   *         -> 0 / _key / different string
   * call 1: [{"_key":"test1"},{"_key":"test2"}]
   *         -> 1 / _key / different object types
   * call 2: [{"_key":"test3"},{"_key":"test2"},{"_key":"test1"}]
   * call 3: [{"_key":"test2"}]
   *
   * @param {Array<string>} additionalInformation
   *      -> will be displayed below each call information
   *         as additional information.
   *
   * @return {string} -> The information about made calls.
   */
  showCallArguments(additionalInformation = []) {
    const allMadeCalls = this[Symbols.calls];
    const madeCalls = SpyHelperFunctions.getCalls(this);
    const earlierCalls = allMadeCalls.length - madeCalls.length;
    const usedAdditionalInfo = new Array(earlierCalls).fill("!!! was called earlier (#enforceOrder)").concat(additionalInformation);
    if (allMadeCalls.length === 0) {
      return `${this[Symbols.name]} was never called!
`;
    }
    let response = "";
    for (let i = 0; i < allMadeCalls.length; i++) {
      const args = serialize(allMadeCalls[i].args);
      response += `call ${i - earlierCalls}: ${args}
`;
      if (usedAdditionalInfo[i]) {
        response += `        ${usedAdditionalInfo[i]}
`;
      }
    }
    return response;
  }
};
const AllCreatedSpies = [];
const _createSpy = (name = "", __mock) => {
  const spy = function(...args) {
    spy[Symbols.calls].push({ args, order: ++CallOrder.Idx });
    if (spy[Symbols.snapSerializer]) {
      spy[Symbols.snap] = spy[Symbols.snapSerializer](...args);
    }
    return spy[Symbols.func](...args);
  };
  if (__mock && !__LOCK__) {
    spy[Symbols.index] = registry.push(__mock.obj, __mock.methodName);
    spy[Symbols.name] = `the spy on '${name}'`;
    spy[Symbols.snap] = `Spy.on(${name})`;
  } else {
    spy[Symbols.index] = 0;
    spy[Symbols.name] = name || "the spy";
    spy[Symbols.snap] = `Spy(${name})`;
  }
  spy[Symbols.isSpy] = true;
  spy[Symbols.func] = () => {
  };
  spy[Symbols.calls] = [];
  spy[Symbols.config] = { ...Config };
  Object.entries(SpyFunctions).forEach(([key, value]) => {
    spy[key] = value;
  });
  AllCreatedSpies.push(spy);
  return spy;
};
const Spy = (name) => _createSpy(name);
Spy.configure = configure;
Spy.IGNORE = IGNORE;
Spy.COMPARE = COMPARE;
Spy.MAPPER = MAPPER;
Spy.on = (obj, methodName) => {
  const method = obj[methodName];
  if (!(typeof method === "function")) {
    throw new Error(
      `The object attribute '${String(methodName)}' was: ${serialize(method)}

You should only spy on functions!`
    );
  }
  if (method[Symbols.isSpy]) {
    throw new Error(
      `The objects attribute '${String(methodName)}' was already spied. Please make sure to spy only once at a time at any attribute.`
    );
  }
  __LOCK__ = false;
  const spy = _createSpy(methodName, { obj, methodName });
  __LOCK__ = true;
  obj[methodName] = spy;
  return spy;
};
Spy.mock = (obj, ...methodNames) => createMock(obj, methodNames, Spy.on);
Spy.mockReactComponents = (obj, ...methodNames) => createMock(obj, methodNames, Spy.on, Config.useGenericReactMocks ? createGenericComponent : createMinimalComponent);
Spy.restoreAll = () => {
  registry.restoreAll();
};
Spy.resetAll = () => {
  AllCreatedSpies.forEach((spy) => spy.reset());
};
const defaultAfterEachCb = () => {
  Spy.restoreAll();
  Spy.resetAll();
};
Spy.setup = (config) => {
  configureAll(config);
  const { beforeEach, afterEach, expect, runner } = Config;
  if (!beforeEach || !afterEach || !expect) {
    const vitestHint = runner === "vitest" ? ` E.g. like this:

import { beforeEach, afterEach, expect } from 'vitest';

Spy.setup({ beforeEach, afterEach, expect });` : "";
    throw new Error(`Please provide "beforeEach", "afterEach" and "expect" functions.${vitestHint}`);
  }
  afterEach(() => {
    const cb = (Config == null ? void 0 : Config.afterEachCb) || defaultAfterEachCb;
    cb();
  });
  expect.addSnapshotSerializer({
    test: (v) => v && v[Symbols.isSpy],
    print: (spy) => spy[Symbols.snap]
  });
};
export {
  Spy
};
